<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/09/2008 *
 * ===============                              Last change: 09/09/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : load_cache-config.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Load more cache files                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mehr Cache-Dateien nachladen                     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Let's start with the admins table...
if (($cacheInstance->cache_file("admins", true) == true)) {
	// Load cache
	global $cacheArray;
	$cacheArray['admins'] = $cacheInstance->cache_load();

	// Check if valid
	if ((is_array($cacheArray['admins']['login'])) && (is_array($cacheArray['admins']['aid']))) {
		// Check count
		if (count($cacheArray['admins']['login']) == count($cacheArray['admins']['aid'])) {
			//* DEBUG: */ echo "<PRE>";
			//* DEBUG: */ print_r($cacheArray['admins']);

			// The cache file seems to be fine
			foreach ($cacheArray['admins']['login'] as $k => $login) {
				// Rewrite default_acl
				$cacheArray['admins']['aid'][$login]      = $cacheArray['admins']['aid'][$k];
				$cacheArray['admins']['password'][$login] = $cacheArray['admins']['password'][$k];
				$cacheArray['admins']['email'][$login]    = $cacheArray['admins']['email'][$k];

				// Some extra data depening on version
				if (GET_EXT_VERSION("admins") >= "0.3") {
					$cacheArray['admins']['def_acl'][$login]  = $cacheArray['admins']['def_acl'][$k];
					if (GET_EXT_VERSION("admins") >= "0.6.7") {
						$cacheArray['admins']['la_mode'][$login]  = $cacheArray['admins']['la_mode'][$k];
					}
				}

				//* DEBUG: */ print_r($cacheArray['admins']);

				// Clear array
				if (isset($cacheArray['admins']['aid'][$k])) 		unset($cacheArray['admins']['aid'][$k]);
				if (isset($cacheArray['admins']['def_acl'][$k]))	unset($cacheArray['admins']['def_acl'][$k]);
				if (isset($cacheArray['admins']['la_mode'][$k]))	unset($cacheArray['admins']['la_mode'][$k]);
				if (isset($cacheArray['admins']['password'][$k]))	unset($cacheArray['admins']['password'][$k]);
				if (isset($cacheArray['admins']['email'][$k]))	unset($cacheArray['admins']['email'][$k]);
			}

			//* DEBUG: */ print_r($cacheArray['admins']);

			// Rewrite Login
			foreach ($cacheArray['admins']['login'] as $k => $login) {
				$cacheArray['admins']['login'][$cacheArray['admins']['aid'][$login]] = $login;
				if (!in_array($k, $cacheArray['admins']['aid'])) {
					unset($cacheArray['admins']['login'][$k]);
				}
			}

			//* DEBUG: */ echo "****\n";
			//* DEBUG: */ print_r($cacheArray['admins']);
			//* DEBUG: */ echo "</PRE>";
			//* DEBUG: */ die();
		} else {
			// Nope, cache file is corrupted!
			$cacheInstance->cache_destroy();
		}
	} else {
		// Nope, cache file is corrupted!
		$cacheInstance->cache_destroy();
		unset($cacheArray['admins']);
	}
} elseif (($_CONFIG['cache_admins'] == "Y") && ($CSS != "1") && ($CSS != "-1")) {
	// Create cache file
	$cacheInstance->cache_init("ADMINS");

	// Load every data from DB to cache file
	$ADD = ", id, id";
	if (GET_EXT_VERSION("admins") >= "0.3")   $ADD  = ", default_acl AS def_acl";
	if (GET_EXT_VERSION("admins") >= "0.6.7") $ADD .= ", la_mode";

	// Query the database about this
	$result_admins = SQL_QUERY("SELECT id AS aid, login, password, email".$ADD."
FROM "._MYSQL_PREFIX."_admins
ORDER BY login", __FILE__, __LINE__);
	while($dummy = SQL_FETCHARRAY($result_admins)) {
		// Save row
		$cacheInstance->add_row($dummy);
	}

	// Free memory
	SQL_FREERESULT($result_admins);
}

// Close file
$cacheInstance->cache_close();

// Next cached table are the admins_acls...
if (GET_EXT_VERSION("admins") >= "0.3") {
	// Check for cache file
	if ($cacheInstance->cache_file("admins_acls", true) == true) {
		// Load referral system from cache
		global $cacheArray;
		$cacheArray['admin_acls'] = $cacheInstance->cache_load();

		// Valid cache file
		$CNT = 0;
		foreach ($cacheArray['admin_acls'] as $k => $array) {
			$CNT += count($array);
		}

		// When there is a period (.) in the result this test will fail and so the cache file is
		// damaged/corrupted
		if (count($cacheArray['admin_acls']) > 0) {
			$TEST = "failed";
			if (count($cacheArray['admin_acls']) > 0 ) $TEST = ($CNT / (count($cacheArray['admin_acls'])));
			if ($TEST != bigintval($TEST)) {
				// Cache file is corrupted!
				$cacheInstance->cache_destroy();
				unset($cacheArray['admin_acls']);
			}
		}
	} elseif (($_CONFIG['cache_acls'] == "Y") && ($CSS != "1") && ($CSS != "-1")) {
		// Create cache file here
		$cacheInstance->cache_init("ADMINS_ACLS");

		// Load all modules and their data
		$result = SQL_QUERY("SELECT id, admin_id, action_menu, what_menu, access_mode FROM "._MYSQL_PREFIX."_admins_acls ORDER BY admin_id, action_menu, what_menu", __FILE__, __LINE__);
		while ($DATA = SQL_FETCHARRAY($result)) {
			// Add row to cache file
			$cacheInstance->add_row($DATA);
		}

		// Free memory
		SQL_FREERESULT($result);
	}

	// Close file
	$cacheInstance->cache_close();
}

//
?>
