<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/09/2008 *
 * ===============                              Last change: 09/09/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : load_cache-config.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Load more cache files                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mehr Cache-Dateien nachladen                     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Next cached table is the configuration (config)...
if ($cacheInstance->cache_file("config", true) == true) {
	// Load config from cache
	global $cacheArray;
	$cacheArrayConfig = $cacheInstance->cache_load();

	// Valid cache file
	$CNT = 0; $newCache = array();
	foreach ($cacheArrayConfig as $key => $array) {
		foreach ($array as $key2 => $value) {
			$newCache[$key2][$key] = $value;
		}
		$CNT += count($array);
	}

	// Overwrite the config with the cache version
	$cacheArray['config'] = $newCache;
	unset($newCache);

	// When there is a period (.) in the result this test will fail and so the cache file is
	// damaged/corrupted
	$TEST = "failed";
	if (count($cacheArray['config']) > 0 ) $TEST = ($CNT / (count($cacheArray['config'])));
	if ($TEST != bigintval($TEST)) {
		// Cache file is corrupted!
		$cacheInstance->cache_destroy();
		unset($cacheArray['config']);
	}
} elseif (($_CONFIG['cache_config'] == "Y") && ($CSS != "1") && ($CSS != "-1")) {
	// Create cache file here
	$cacheInstance->cache_init("CONFIG");

	// Load all modules and their data
	$result = SQL_QUERY("SELECT * FROM "._MYSQL_PREFIX."_config ORDER BY config", __FILE__, __LINE__);
	while ($DATA = SQL_FETCHARRAY($result)) {
		// Add row to cache file
		$cacheInstance->add_row($DATA);
	}

	// Free memory
	SQL_FREERESULT($result);
}

// Close file
$cacheInstance->cache_close();

//
?>
