<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/05/2008 *
 * ================                             Last change: 09/08/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-surfbar_start.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Gives some infos to the surfbar and launch link  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Gibt ein paar Infos zur Surfbar und Startlink    *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif (!IS_MEMBER()) {
	// Not logged in
	LOAD_URL("modules.php?module=index");
} elseif (!EXT_IS_ACTIVE("surfbar")) {
	// Extension "surfbar" is not active
	ADD_FATAL(EXTENSION_PROBLEM_EXT_INACTIVE, "surfbar");
	return;
}

// Add description as navigation point
ADD_DESCR("member", basename(__FILE__));

// Prepare content for output
$content = array(
	'surfbar_static_reward'   => TRANSLATE_COMMA($_CONFIG['surfbar_static_reward']),
	'surfbar_static_time'     => CREATE_FANCY_TIME($_CONFIG['surfbar_static_time']),
	'surfbar_static_lock'     => CREATE_FANCY_TIME($_CONFIG['surfbar_static_lock']),
	'surfbar_dynamic_percent' => TRANSLATE_COMMA($_CONFIG['surfbar_dynamic_percent'])
);

// Load the template
LOAD_TEMPLATE("member_surfbar_start_".strtolower($_CONFIG['surfbar_pay_model']), false, $content);

// Load surfbar link template
LOAD_TEMPLATE("member_surfbar_link");

//
?>
